unit UEELSBoson;

{$mode objfpc}
{$H+}

interface

uses
  Classes, SysUtils;

type
// Fortran equivalents
  Finteger = int32;
  Fdouble  = double;
  Flogical  = boolean;
  Fosc_array = array[1..3] of Fdouble;

var
// for EELS
  ImpactEnergy: Fdouble;
  IncidenceAngle: Fdouble;
  AngularAperturePhiA: Fdouble;
  AngularAperturePhiB: Fdouble;
  IntervalWMin: Fdouble;
  IntervalWMax: Fdouble;
  IntervalWDelta: Fdouble;
  Comment1: string;
  Comment2: string;
  Comment_size:     Finteger;
  Comment1_length:  integer;
  NumberOfPeriodic: Finteger;
  NumberOfLayers:   Finteger;
  NumberOfEpsilons: Finteger;
  LayerName:  array of string;
  LayerName_length: integer;
  Thickness:  array of Fdouble;
  Epsilon:    array of Fdouble;
  NumberOfOscillators: array of Finteger;
  Oscillator: array of Fosc_array;
  Oscillator_length: integer;
  Control: string;
  Mode:    string;
  Wn_Array: array of Fdouble;
  Debug: Flogical;
  F_Array:  array of Fdouble;
// for Boson
  TargetTemperature: Fdouble;
  InstrumentalWidth: Fdouble;
  GaussianFraction: Fdouble;
  Asymmetry: Fdouble;
  EMin: Fdouble;
  EMax: Fdouble;
  Title1: string;
  Title2: string;
  IntervalNW: Finteger;
  xout, yout: array of Fdouble;
  nout: Finteger;

procedure doeels(var e0: Fdouble;
                 var theta: Fdouble;
                 var phia,  phib: Fdouble;
                 var wmin, wmax, dw: Fdouble;
                 var comment: string; var size_comment: Finteger;
                 var layers: Finteger;
                 var neps: Finteger;
                 var nper: Finteger;
                 var name: array of  string; var size_name: Finteger;
                 var thick:  array of Fdouble;
                 var epsinf: array of Fdouble;
                 var nos: array of Finteger;
                 var osc: array of Fosc_array;
                 var size_osc: Finteger;
                 var contrl: string;
                 var mode:   string;
                 var wn_array: array of Fdouble;
                 var debug: Flogical;
                 var f_array:  array of Fdouble;
                 var size_wn_array: Finteger);
  cdecl; external name 'doeels_';

procedure doboson(var t: Fdouble;
                  var width: Fdouble;
                  var gauss: Fdouble;
                  var asym: Fdouble;
                  var emin: Fdouble;
                  var emax: Fdouble;
                  var wmin: Fdouble;
                  var wmax: Fdouble;
                  var np: Finteger;
                  var p: array of Fdouble;
                  var xout, yout: array of Fdouble;
                  var nout: Finteger);
  cdecl; external name 'doboson_';

implementation

end.

