double precision function respon(w, width)

!*******************************************************************
!                                                                  *
! instrumental response of the spectrometer for the frequency w    *
! width is the full width at half maximum of the response function *
!                                                                  *
!*******************************************************************

  implicit none
  double precision, intent(in) :: w, width

  double precision :: u

  u = 1.25d0 * w / width
  if (u <= -1.0d0 .or. u >= 2.0d0) then
     respon = 0.0d0
  elseif (u > 1.0d0) then
     respon = 4.0d0 + 2 * dsqrt((u - 1.0d0)**3) - 3 * u
  elseif (u > 0.0d0) then
     respon = 2.0d0 - 4 * dsqrt(u**3) + 3 * u
  else
     respon = 2 * dsqrt((u + 1.0d0)**3)
  endif
  return
end function respon
