double precision function usurlo(dq, wn)

! ******************************************************************
! *                                                                *
! * user-supplied dielectric surface loss function aimag(g(dq, wn)) *
! * input arguments :                                              *
! *    dq : modulus of the two-dimensional surface wave vector     *
! *         (angstroem**-1)                                        *
! *    wn : frequency (cm**-1)                                     *
! *                                                                *
! ******************************************************************

  implicit none

  double precision, intent(in out) :: dq
  double precision, intent(in out) :: wn

  if ((wn .GT. 0) .AND. (dq .GT. 0)) then
    write(*,*) 'hello, here is the user loss function'
  endif
  usurlo = 1.0d0
  return
end function usurlo
