      PROGRAM EELS                                                      
C    ****************************************************************** 
C    *                                                                * 
C    * COMPUTE THE CLASSICAL EELS SPECTRUM OF AN ARBITRARY PLANE-     * 
C    * STATIFIED MEDIUM MADE FROM ISOTROPIC MATERIALS IN SPECULAR     * 
C    * GEOMETRY USING THE DIELECTRIC THEORY OF EELS.                  * 
C    *                                                                * 
C    ****************************************************************** 
      PARAMETER(LMAX=100,JMAX=300,NT=5)                                 
      LOGICAL RATION,USER                                               
      CHARACTER CONTRL*10,NAME*10,COMMEN*72                             
      DOUBLE PRECISION A,ACOEF,AERR,ALPHA,ARGMIN,ARGMAX,B,BCOEF,BETA,   
     ,C1,C2,CCOEF,COSPSI,DLIMF,DW,DX,E0,ELLEPS,ENER,EPSINF,EPSMAC,      
     ,FACRU,F,F0,F1,FPIC,FUN,OSC,PHIA,PHIB,PI,PREFAC,PSIA,PSII,QRAT,    
     ,RERR,RU,SINPSI,T,TANPSI,TABLE,THETA,THICK,UM,WIDT,WMIN,WMAX,WN,   
     ,WPIC,X,XMIN,XMAX,Z,Z1,Z2                                          
      COMPLEX EPS                                                       
      DIMENSION COMMEN(2),EPSINF(LMAX),NOS(LMAX),OSC(3,JMAX),TABLE(NT)  
      DIMENSION NAME(LMAX)
      COMMON/PARAM/ACOEF,BCOEF,CCOEF,ELLEPS,COSPSI,SINPSI,TANPSI,       
     1             RU,UM,DLIMF,WN,USER,RATION                           
      COMMON/MULAYR/EPS(LMAX),THICK(LMAX),ARGMIN,ARGMAX,EPSMAC,         
     2              LAYERS,NPER                                         
      EXTERNAL FUN                                                      
      QRAT(X) = (1.0D0+X*(BETA+C1*X))/((1.0D0+X*(BETA+C2*X))*           
     *            (1.0D0+ALPHA*X)**2)                                   
      DATA AERR/0.0D0/,RERR/1.0D-06/,F/0.0D0/,F1/0.0D0/                 
C                                                                       
C *** MACHINE-DEPENDENT CONSTANTS                                       
C *** EPSMAC + 1.0 = EPSMAC , COSH(ARGMIN) = 1.0 , TANH(ARGMAX) = 1.0   
C                                                                       
      PI = 4.0D0*ATAN(1.0D0)                                            
      EPSMAC = 1.0D0                                                    
    1 EPSMAC = EPSMAC/2.0D0                                             
      IF(1.0D0+EPSMAC.GT.1.0D0) GOTO 1                                  
      ARGMIN = SQRT(2.0D0*EPSMAC)                                       
      ARGMAX = 0.5D0*LOG(2.0D0/EPSMAC)                                  
C                                                                       
C *** READ SPECTROMETER PARAMETERS                                      
C                                                                       
      call change_working_dir()
      OPEN(UNIT=11,FILE='EELSIN')                                       
C     IMPACT ENERGY (EV)                                                
      READ(11,*) E0                                                     
C     INCIDENCE ANGLE (%)                                               
      READ(11,*) THETA                                                  
C     ANGULAR APERTURES OF THE ELLIPTIC DETECTOR (%)                    
      READ(11,*) PHIA                                                   
      READ(11,*) PHIB                                                   
C     ENERGY-LOSS INTERVAL AND STEP SIZE (CM**-1)                       
      READ(11,*) WMIN                                                   
      READ(11,*) WMAX                                                   
      READ(11,*) DW                                                     
C     COMMENT LINES                                                     
      READ(11,'(A72)') (COMMEN(K),K=1,2)                                
C                                                                       
      WRITE(6,100) E0,THETA,PHIA,PHIB,WMIN,WMAX,DW,(COMMEN(K),K=1,2)    
      IF(PHIA.LE.0.0D0 .OR. PHIB.LE.0.0D0) STOP '*** WRONG INPUT ***'   
      IF(E0.LE.0.0D0 .OR. THETA+PHIA.GE.90.0D0) STOP '*** BAD INPUT ***'
      DLIMF = 0.0D0                                                     
      RATION = .FALSE.                                                  
C                                                                       
C *** READ TARGET SPECIFICATIONS                                        
C                                                                       
      READ(11,*) LAYERS,NPER                                            
      USER = LAYERS.EQ.0                                                
      IF(USER) GOTO 15                                                  
      NEPS = LAYERS                                                     
      IF(NPER.EQ.-1) THEN                                               
         NEPS = LAYERS+1                                                
         NPER = 1                                                       
         WRITE(6,*) 'THE SUBSTRATE IS A ANISOTROPIC UNIAXIAL MATERIAL'  
      ENDIF                                                             
      IF(LAYERS.LT.0 .OR. NPER.LT.1 .OR. NPER.GT.LAYERS) STOP           
     .                '*** INVALID TARGET SPECIFICATIONS ***'           
      IF(NEPS.GT.LMAX) STOP '*** TOO MANY LAYERS ***'                   
      WRITE(6,101) LAYERS,NPER                                          
      IF(LAYERS.EQ.1) RATION = .TRUE.                                   
      LSTART = LAYERS-NPER+1                                            
      JOS = 0                                                           
      DO 10 L=1,NEPS                                                    
         IF(L.LE.LAYERS) READ(11,102) NAME(L),THICK(L)                  
         READ(11,*) EPSINF(L),NOS(L)                                    
         WRITE(6,103)
C        IF(L.EQ.LSTART) WRITE(6,103)                                   
         IF(NOS(L).LE.0) THEN                                           
            IF(L.LE.LAYERS) WRITE(6,104) L,NAME(L),THICK(L),EPSINF(L)   
            IF(L.GT.LAYERS) WRITE(6,105) EPSINF(L)                      
         ELSE                                                           
            DO 5 J=1,NOS(L)                                             
               JOS = JOS+1                                              
               IF(JOS.GT.JMAX) STOP '*** TOO MANY OSCILLATORS ***'      
               READ(11,*) (OSC(K,JOS),K=1,3)                            
               IF((J==NOS(L)/2+1).AND.(NOS(L).GT.1)) THEN
                  WRITE(6,114)
                  WRITE(6,115)
               ENDIF
               IF(J.EQ.1) THEN                                          
                  IF(L.LE.LAYERS) WRITE(6,104) L,NAME(L),THICK(L),      
     ,                             EPSINF(L),(OSC(I,JOS),I=1,3)         
                  IF(L.GT.LAYERS) WRITE(6,105)                          
     .                             EPSINF(L),(OSC(I,JOS),I=1,3)         
               ELSE                                                     
                  WRITE(6,106) (OSC(I,JOS),I=1,3)                       
               ENDIF                                                    
    5       CONTINUE                                                    
         ENDIF                                                          
   10 CONTINUE                                                          
      WRITE(6,*)                                                        
      READ(11,102,END=15) CONTRL                                        
      IF(CONTRL.EQ.'IMAGE') THEN                                        
C ***    IMAGE-CHARGE SCREENING FACTOR                                  
         IF(LAYERS.EQ.1 .AND. NEPS.EQ.2) THEN                           
            DLIMF = SQRT(EPSINF(1)*EPSINF(2))                           
         ELSE                                                           
            DLIMF = EPSINF(1)                                           
         ENDIF                                                          
         DLIMF = (DLIMF-1.0D0)/(DLIMF+1.0D0)                            
      ENDIF                                                             
C                                                                       
C *** INITIALIZE CONSTANTS                                              
C                                                                       
   15 OPEN(UNIT=12,FILE='EELSOU')                                       
      WRITE(12,107) E0,THETA,PHIA,PHIB,COMMEN(1)                        
      NW = 1+INT((WMAX-WMIN)/DW)                                        
      NOUT = 1+NW/20                                                    
      ENER = 8.065D+03*E0                                               
      PSIA = PHIA/180.0D0*PI                                            
      PSII = THETA/180.0D0*PI                                           
      COSPSI = COS(PSII)                                                
      SINPSI = SIN(PSII)                                                
      TANPSI = TAN(PSII)                                                
      PREFAC = SQRT(2.555D+05/E0)/(1.37D+02*COSPSI)                     
      FACRU = PSIA/COSPSI*SQRT(0.2624664D0*E0)                          
      ELLEPS = (1.0D0-PHIA/PHIB)*(1.0D0+PHIA/PHIB)                      
      ACOEF = SINPSI**2+ELLEPS*COSPSI**2                                
      BCOEF = SINPSI*COSPSI                                             
      IF(DLIMF.GT.0.0D0) THEN                                           
         RATION = .FALSE.                                               
         WRITE(6,108) DLIMF                                             
C ***    DLIMF : HALF THE LENGTH UNIT IMPOSED BY THE IMAGE FORCE        
         DLIMF = 1.80D0*DLIMF/(E0*COSPSI**2)                            
      ENDIF                                                             
      IF(.NOT.RATION) GOTO 35                                           
C                                                                       
C *** SET UP COEFFICIENTS FOR THE RATIONAL APPROXIMATION TO THE INTEGRAL
C                                                                       
      WRITE(6,*) '==> SET UP A RATIONAL APPROXIMATION TO THE INTEGRAL'  
      CALL QUANC8(FUN,0.0D0,PI/2.0D0,AERR,RERR,ALPHA,C1,NOFU,C2)        
      ALPHA  = (2.0D0/PI)**2*ALPHA                                      
      C1 = 2.0D0/PI/SQRT(1.0D0-ELLEPS)*SINPSI*ALPHA**2                  
      IF(C1.GT.0.99D0) GOTO 30                                          
      C2 = 3.0D0*ALPHA**2/(1.0D0-C1)                                    
      C1 = C1*C2                                                        
      XMIN = WMIN/(2.0D0*ENER*PSIA)                                     
      XMAX = WMAX/(2.0D0*ENER*PSIA)                                     
      IF(XMIN.LE.0.0D0) XMIN = 0.0D0                                    
      DX = MAX(0.02D0,(XMAX-XMIN)/NT)                                   
      Z1 = 0.0D0                                                        
      Z2 = 0.0D0                                                        
      DO 20 I=1,NT                                                      
         X = XMIN+I*DX                                                  
         CALL QUEELS(X,F,AERR,RERR,FACRU)                               
         TABLE(I) = F                                                   
         F = F*(1.0D0+ALPHA*X)**2                                       
         IF(ABS(C2*F-C1).LT.C2*RERR) GOTO 20                            
         Z = (1.0D0-F)/(C2*F-C1)                                        
         IF(Z.LE.0.0D0) GOTO 20                                         
         Z1 = Z1+X*Z*(X**2-Z)                                           
         Z2 = Z2+(X*Z)**2                                               
   20 CONTINUE                                                          
      IF(Z2.EQ.0.0D0) GOTO 30                                           
      BETA = Z1/Z2                                                      
      Z = 0.0D0                                                         
      DO 25 I=1,NT                                                      
         X = XMIN+I*DX                                                  
         Z = Z+(TABLE(I)-QRAT(X))**2                                    
   25 CONTINUE                                                          
      Z = SQRT(Z)/NT                                                    
      IF(Z.GT.5.0D-03) GOTO 30                                          
      WRITE(6,109) ALPHA,C1,C2,BETA,Z                                   
      GOTO 35                                                           
   30 WRITE(6,*) '===> CANNOT DO IT'                                    
      RATION = .FALSE.                                                  
C                                                                       
C *** LOOP OVER THE ENERGY LOSSES                                       
C                                                                       
   35 WRITE(6,110)                                                      
      DO 50 IW=1,NW                                                     
         F0 = F1                                                        
         F1 = F                                                         
         F = 0.0D0                                                      
         WN = WMIN+(IW-1)*DW                                            
         IF(WN.LT.0.0D0) GOTO 45                                        
         IF(WN.EQ.0.0D0) GOTO 40                                        
         IF(.NOT.USER) CALL SETEPS(NEPS,NOS,OSC,JOS,EPSINF,WN,NAME)         
         X = WN/(2.0D0*ENER*PSIA)                                       
         IF(RATION) THEN                                                
            F = QRAT(X)*AIMAG(-2.0/(1.0+EPS(1)))                        
         ELSE                                                           
            CALL QUEELS(X,F,AERR,RERR,FACRU)                            
         ENDIF                                                          
         F = PREFAC*F/WN                                                
   40    WRITE(12,111) WN,F                                             
C ***    LOCALIZE A PEAK USING A PARABOLIC INTERPOLATION                
         IF(IW.LT.3) GOTO 45                                            
         IF(F1-F0.LE.AERR) GOTO 45                                      
         IF(F1-F.LE.AERR) GOTO 45                                       
         A = (F1-F0)+(F1-F)                                             
         IF(A.LE.4.0D0*RERR*F1) GOTO 45                                 
         B = 0.5D0*(F1-F0+3.0D0*(F1-F))                                 
         T = B/A                                                        
         WPIC = WN-T*DW                                                 
         FPIC = F+0.5D0*B*T                                             
         WIDT = SQRT(8.0D0*FPIC/A)*DW                                   
         WRITE(6,112) WPIC,FPIC,WIDT                                    
   45    IF(MOD(IW,NOUT).EQ.0) WRITE(6,113) 100.0*IW/NW,WN,F            
   50 CONTINUE                                                          
      CLOSE(UNIT=11)                                                    
      CLOSE(UNIT=12)                                                    
      STOP                                                              
  100 FORMAT(' PROGRAM EELS (MARCH 1990)'/' E0 =',F6.2,' EV ,  THETA =',
     ,       F5.1,'% ,  PHIA =',F5.2,'% ,  PHIB =',F5.2,'%'/            
     .       ' ENERGY LOSSES FROM',G11.4,'  TO',G11.4,' , STEP =',G11.4,
     ,       ' CM**-1'//(1X,A72))                                       
  101 FORMAT(I3,' LAYER(S), NPER =',I2//'   L',2X,'MATERIAL',7X,        
     ,       'THICKNESS',5X,'EPSINF',4X,'WTO , WP',5X,'Q',7X,'GAM/WTO') 
  102 FORMAT(A10,D15.5)                                                 
  103 FORMAT(1X,72('-'))                                                
  104 FORMAT(1X,I3,2X,A10,G15.3,F10.4,F12.4,F10.4,F9.4)                 
  105 FORMAT(31X,F10.4,F12.4,F10.4,F9.4)                                
  106 FORMAT(41X,F12.4,F10.4,F9.4)                                      
  107 FORMAT('E0 =',F6.2,' THETA =',F5.1,' PHIA =',F5.2,' PHIB =',F5.2/ 
     .       A72)                                                       
  108 FORMAT(' ==> ELECTRON ATTRACTED BY AN IMAGE CHARGE =',F6.3)       
  109 FORMAT(5X,'ALPHA =',F9.4,4X,'C1 =',F9.4,4X,'C2 =',F9.4,4X,        
     ,       'BETA =',F9.4/5X,'ACCURACY =',E9.2)                        
  110 FORMAT(//' RUN (%)  WN (CM**-1)  PCL(WN) (CM) |',                 
     ,          ' PEAK LOCATION  AMPLITUDE    WIDTH')                   
  111 FORMAT(2E15.7)                                                    
  112 FORMAT(40X,F10.2,D12.4,F10.2)                                     
  113 FORMAT(2X,F5.1,3X,F11.3,D14.5)                                    
  114 FORMAT(45X,'WLO , WP',5X,'Q',7X,'GAM/WLO')
  115 FORMAT(45X,28('-')) 
      END                                                               
