      DOUBLE PRECISION FUNCTION FINT3(U)                                
C    ****************************************************************** 
C    *                                                                * 
C    * INTEGRATION OVER THE AZIMUTAL ANGLE FROM PHI1 > 0 TO PHI2 < PI * 
C    *                                                                * 
C    ****************************************************************** 
      LOGICAL RATION,USER                                               
      DOUBLE PRECISION A,ARG,B,CCOEF,COSPSI,DLIMF,ELLEPS,PHI1,PHI2,     
     ,PHINT,SINPSI,SURLOS,RAC,RU,U,UM,USURLO,T,TANPSI,WN                
      COMMON/PARAM/A,B,CCOEF,ELLEPS,COSPSI,SINPSI,TANPSI,RU,UM,DLIMF,   
     ,             WN,USER,RATION                                       
      IF(U.EQ.0.0D0) THEN                                               
         FINT3 = 0.0D0                                                  
         RETURN                                                         
      ENDIF                                                             
      RAC = SIGN(1.0D0,A)*COSPSI*SQRT((1.0D0-ELLEPS)*A*(UM-U)*(UM+U))   
      ARG = (B-RAC)/(U*A)                                               
      IF(ABS(ARG).GT.1.0D0) ARG = SIGN(1.0D0,ARG)                       
      PHI2 = ACOS(ARG)                                                  
      FINT3 = PHINT(PHI2,TANPSI,U)                                      
      ARG = (B+RAC)/(U*A)                                               
      IF(ABS(ARG).GT.1.0D0) ARG = SIGN(1.0D0,ARG)                       
      PHI1 = ACOS(ARG)                                                  
      FINT3 = FINT3-PHINT(PHI1,TANPSI,U)                                
      IF(RATION) RETURN                                                 
      IF(USER) THEN                                                     
         FINT3 = FINT3*USURLO(RU*U,WN)                                  
      ELSE                                                              
         FINT3 = FINT3*SURLOS(RU*U)                                     
         IF(DLIMF.GT.0.0D0) THEN                                        
            T = RU*U*DLIMF                                              
            FINT3 = FINT3*(1.D0+T*LOG(T/(T+0.26D0)))**2/(1.D0+1.40D0*T) 
         ENDIF                                                          
      ENDIF                                                             
      RETURN                                                            
      END                                                               
