      SUBROUTINE SETEPS(NEPS,NOS,OSC,JOS,EPSINF,WN,NAME)                    
C    ****************************************************************** 
C    *                                                                * 
C    * SET UP LONG-WAVELENGTH DIELECTRIC FUNCTIONS OF THE LAYERS FOR  * 
C    * THE PRESENT FREQUENCY WN (IN CM**-1)                           * 
C    *                                                                * 
C    ****************************************************************** 
      PARAMETER(LMAX=100)                                               
      CHARACTER NAME*10
      DOUBLE PRECISION ARGMIN,ARGMAX,EPSINF,EPSMAC,OSC,THICK,WN,X       
      COMPLEX DENO,EPS,DENO1,DENO2                                      
      DIMENSION NOS(NEPS),OSC(3,JOS),EPSINF(NEPS),NAME(NEPS)           
      COMMON/MULAYR/EPS(LMAX),THICK(LMAX),ARGMIN,ARGMAX,EPSMAC,         
     ,              LAYERS,NPER                                         
      J = 0                                                             
      DO 2 L=1,NEPS
         M = NOS(L)/2
         DENO1 = CMPLX(1.0D0,0.0D0)
         DENO2 = CMPLX(1.0D0,0.0D0)
         IF(NOS(L).GT.1) THEN
            DO 1 K=1,M
               J = J+1
       DENO1 = DENO1*(OSC(1,J+M)**2-WN**2-CMPLX(0.0,WN*OSC(3,J+M)))
       DENO2 = DENO2*(OSC(1,J  )**2-WN**2-CMPLX(0.0,WN*OSC(3,J  )))
    1       CONTINUE
            EPS(L) = EPSINF(L)*DENO1/DENO2
         ELSE IF(NAME(L).EQ.'metal') THEN
            J = J+1
            EPS(L) = -OSC(1,J)**2/( WN**2+CMPLX(0.0D0,WN*OSC(3,J)) )
         ELSE
            EPS(L) = EPSINF(L)
      do k = 1, nos(l)
            J = J+1
            X = WN/OSC(1,J)
            DENO = X*CMPLX(X,OSC(3,J))
            IF(OSC(2,J).GE.0.0D0) DENO = 1.0-DENO
            IF(ABS(DENO).EQ.0.0) DENO = EPSMAC
            EPS(L) = EPS(L)+OSC(2,J)/DENO
      enddo
         ENDIF
    2 CONTINUE                                                          
      IF(NEPS.EQ.LAYERS+1) THEN                                         
C        THE SUBSTRATE IS A ANISOTROPIC UNIAXIAL MATERIAL               
         EPS(LAYERS) = SQRT(EPS(LAYERS)*EPS(LAYERS+1))                  
         IF(AIMAG(EPS(LAYERS)).LT.0.0) EPS(LAYERS) = -EPS(LAYERS)       
      ENDIF                                                             
      RETURN                                                            
      END                                                               
